<%@include file="/include-internal.jsp" %>
<%@ taglib prefix="props" tagdir="/WEB-INF/tags/props" %>
<%@ taglib prefix="l" tagdir="/WEB-INF/tags/layout" %>
<%@ taglib prefix="forms" tagdir="/WEB-INF/tags/forms" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<jsp:useBean id="publicKey" scope="request" type="java.lang.String"/>
<jsp:useBean id="action" scope="request" type="java.lang.String"/>
<jsp:useBean id="form" scope="request" type="jetbrains.buildServer.clouds.server.web.admin.CloudAdminProfileForm"/>
<jsp:useBean id="extensions" scope="request" type="java.util.Collection<jetbrains.buildServer.clouds.CloudTypeExtension>"/>

<c:set var="ajaxUrl"><c:url value="/clouds/admin/cloudAdminProfile.html"/></c:set>
<div class="adminProfileDialogScrollable">
<table class="runnerFormTable">
  <tr>
    <th><label for="profileName">Profile Name:<l:star/></label></th>
    <td>
      <props:textProperty name="profileName"/>
      <span id="error_profileName" class="error"></span>
    </td>
  </tr>
  <tr>
    <th><label for="profileDescription">Description:</label></th>
    <td>
      <props:textProperty name="profileDescription"/>
      <span id="error_profileDescription"></span>
    </td>
  </tr>
  <tr>
    <th><label for="terminateTimeOut">Terminate Instance Idle Time:</label></th>
    <td>
      <props:textProperty name="terminateTimeOut"/>
      <span id="error_terminateTimeOut" class="error"></span>
      <span class="smallNote">Minutes to wait before stopping idle build agent</span>
    </td>
  </tr>
  <tr>
    <th><label for="cloudType">Cloud Type:<l:star/></label></th>
    <td>
      <select name="cloudType" id="cloudType" onchange="BS.Clouds.Admin.CreateProfileDialog.refreshDialog();">
        <forms:option value="" selected="${empty form.selectedTypeCode}">--- Choose cloud type ---</forms:option>
        <c:forEach items="${form.cloudTypes}" var="type">
          <forms:option value="${type.cloudCode}" selected="${not empty form.selectedTypeCode and type.cloudCode eq form.selectedTypeCode}"><c:out value="${type.displayName}"/></forms:option>
        </c:forEach>
      </select>
      <forms:saving id="newProviderSaving" style="float: none;"/>
      <span class="error" id="error_cloudType"></span>
    </td>
  </tr>
</table>

<bs:refreshable containerId="newProfilesContainer" pageUrl="${ajaxUrl}">
  <c:if test="${not empty form.selectedType}">
    <table class="runnerFormTable">
    <c:choose>
      <c:when test="${not empty form.selectedType.editProfileUrl}">
          <jsp:include page="${form.selectedType.editProfileUrl}"/>
      </c:when>
      <c:otherwise>
        <tr>
          <td colspan="2">
            <div class="smallNote" style="margin-left: 0;">There are no additional options.</div>
          </td>
        </tr>
      </c:otherwise>
    </c:choose>
    <c:forEach var="ext" items="${extensions}">
      <jsp:useBean id="ext" type="jetbrains.buildServer.clouds.CloudTypeExtension"/>
      <!-- Cloud profile form extension: ${ext.class} -->
      <jsp:include page="${ext.includeUrl}"/>
      <!-- End of: Cloud profile form extension: ${ext.class} -->
    </c:forEach>
    </table>
  </c:if>

  <input type="hidden" id="publicKey" name="publicKey" value="${publicKey}"/>
  <input type="hidden" id="action" name="action" value="${action}"/>
  <c:if test="${not empty form.selectedProfile}">
    <input type="hidden" id="profileId" name="profileId" value="${form.selectedProfile.profileId}"/>
  </c:if>
</bs:refreshable>
</div>

<div class="popupSaveButtonsBlock">
  <a href="javascript://" onclick="BS.Clouds.Admin.CreateProfileDialog.close();" class="cancel" showdiscardchangesmessage="false">Cancel</a>
  <input type="submit" class="submitButton" value="${form.submitButtonCaption}" id="createButton"/>
  <forms:saving id="newProfileProviderProgress"/>
  <div class="clr"></div>
</div>
<div class="clr"></div>

